#include "itbase.h"

using std::cout;
using std::endl;
using namespace itpp;

int main(){

  cout << "======================================" << endl;
  cout << "        Test of filter routines" << endl;
  cout << "======================================" << endl;

  // Test signals
  vec x(20);
  x.zeros();
  x(0) = 1.0;
  x(2) = 0.5;

  cvec cx(20);
  cx.zeros();
  cx(0) = 1.0;
  cx(2) = 0.5;

  // Filter coefficients
  vec coeff(10);
  coeff.ones(); coeff(0)+= 0.1;
  cvec ccoeff(10);
  ccoeff.ones(); ccoeff(0)+= 0.1;

  MA_Filter<double,double,double> H(coeff);
  MA_Filter<complex<double>,double,complex<double> > CH(coeff);
  MA_Filter<complex<double>,complex<double>,complex<double> > C(ccoeff);

  vec y = H(x);
  cout << "output = " << y << endl;

  cvec cy = CH(cx);
  cout << "output = " << cy << endl;

  cy = C(cx);
  cout << "output = " << cy << endl;

  y =  filter<double,double,double>(coeff,1,x);
  cout << "output = " << y << endl;

  cy =  filter<complex<double>,double,complex<double> >(coeff,1,cx);
  cout << "output = " << cy << endl;

  cy =  filter<complex<double>,complex<double>,complex<double> >(ccoeff,1,cx);
  cout << "output = " << cy << endl;

  ccoeff.set_length(2);
  ccoeff(0) = 1.0; ccoeff(1) = -1.0;
  coeff.set_length(2);
  coeff(0) = 1.0; coeff(1) = -1.0;

  AR_Filter<double,double,double> HAR(coeff);
  AR_Filter<complex<double>,double,complex<double> > CHAR(coeff);
  AR_Filter<complex<double>,complex<double>,complex<double> > CAR(ccoeff);

  y = HAR(x);
  cout << "output = " << y << endl;

  cy = CHAR(cx);
  cout << "output = " << cy << endl;

  cy = CAR(cx);
  cout << "output = " << cy << endl;

  y =  filter<double,double,double>(1,coeff,x);
  cout << "output = " << y << endl;

  cy =  filter<complex<double>,double,complex<double> >(1,coeff,cx);
  cout << "output = " << cy << endl;

  cy =  filter<complex<double>,complex<double>,complex<double> >(1,ccoeff,cx);
  cout << "output = " << cy << endl;


  y =  filter<double,double,double>("1",coeff,x);
  cout << "output = " << y << endl;

  cy =  filter<complex<double>,double,complex<double> >("1",coeff,cx);
  cout << "output = " << cy << endl;

  cvec ca(1); ca(0)= 1;;

  cy =  filter<complex<double>,complex<double>,complex<double> >(ca,ccoeff,cx);
  cout << "output = " << cy << endl;
}
